unit MMP3Info;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  type
    MP3Tag = 
      packed record
        Title : string[30]; 
        Artist : string[30]; 
        Album : string[30]; 
        Year : string[4]; 
        Comments : string[30]; 
      end;

  function GetMP3Info( var MP3File : widestring ) : MP3Tag;
  function TimeString( var Seconds : longint ) : widestring;
  function FileLength : longint;
  function FileLocation : longint;

  function mciSendString( lpstrCommand : pchar; lpstrReturnString : pchar; uReturnLength : longint; hwndCallback : longint ) : longint; stdcall; external 'winmm.dll' name 'mciSendStringA';
  function SetParent( hWndChild : longint; hWndNewParent : longint ) : longint; stdcall; external 'user32';

implementation

  var
    Buffer : string[255]; 

  function GetMP3Info( var MP3File : widestring ) : MP3Tag;
    var
      // MP3      
      InfoTag : longint; 
    label
      errHandler;
    begin
      //ON ERROR
      //  
      CloseAllFiles{UNSUPPORTED};
      Assign( file1, MP3File ); 
      Reset( file1 );
      //    
      Seek( file1, ( LOF( 1 ) - 256 ) );
      Read( file1, Buffer );
      CloseFile( file1 );
      //   
      InfoTag := PosEx('tag', Buffer, 1);
      //      
      if ( InfoTag = 0 )
        then
          begin
            //MsgBox "      ", vbOKOnly, "MP3"
            exit;
          end;
      // MP3-         
      with result do
        begin
          Title := Copy(Buffer, InfoTag + 3, 30);
          Artist := Copy(Buffer, InfoTag + 33, 30);
          Album := Copy(Buffer, InfoTag + 63, 30);
          Year := Copy(Buffer, InfoTag + 93, 30);
          Comments := Copy(Buffer, InfoTag + 97, 30);
        end;
      CloseAllFiles{UNSUPPORTED};
      exit;
      errHandler:
      CloseAllFiles{UNSUPPORTED};
      Application.MessageBox( pchar('File Error!'), pchar('MP3'), vbCritical ) {HelpFile:None, Context:None};
      Player.mediafile := '';
    end;

  function TimeString( var Seconds : longint ) : widestring;
    var
      //convert seconds to mm:ss format
      Mins : longint; 
    begin
      if ( Seconds < 60 )
        then
          begin
            result := '0:' + RightStr('0' + Seconds, 2);
          end;
      if ( Seconds > 59 )
        then
          begin
            Mins := Floor( Seconds / 60 );
            Seconds := Seconds - ( Mins * 60 );
            result := RightStr('0' + Str( Mins ), 2) + ':' + RightStr('0' + Seconds, 2);
          end;
      if PosEx(' ', result, 1)
        then
          begin
            result := StuffString( result, PosEx(' ', result, 1), 1, '' );
          end;
    end;

  function FileLength : longint;
    var
      ml : widestring; 
    begin
      ml := StringOfChar(#32, 30);
      mciSendString( 'set myfile time format ms', 0, 0, 0 );
      mciSendString( 'status myfile length ', ml, 30, 0 ); //, , "mci: Calculate playtime"
      result := Val( ml );
    end;

  function FileLocation : longint;
    var
      ml : widestring; 
    begin
      ml := StringOfChar(#32, 30);
      mciSendString( 'set myfile time format ms', 0, 0, 0 );
      mciSendString( 'status myfile position ', ml, 30, 0 ); //, , "mci: Calculate playtime"
      result := Val( ml );
    end;

end.
