unit MainModule;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  const
    RGN_OR : smallint = 2; 
    WM_NCLBUTTONDOWN : smallint = $000000A1; 
    HTCAPTION : smallint = 2; 
    HWND_TOPMOST : smallint = -1; 
    HWND_NOTOPMOST : smallint = -2; 
    SWP_NOSIZE : smallint = $00000001; 
    SWP_NOMOVE : smallint = $00000002; 
    SWP_NOACTIVATE : smallint = $00000010; 
    SWP_SHOWWINDOW : smallint = $00000040; 
    SWP_NOZORDER : longint = $00000004; 

  var
    LstData : array[0..1000] of widestring; 

  procedure SetVol( var Volume : smallint; var Midi : boolean{ = false} );
  function GetVol( var Midi : boolean{ = false} ) : smallint;
  function MakeRegion( var picSkin : TPaintBox ) : longint;
  function Percent( var Val : longint; var Percnt : smallint ) : longint;
  //Public Function GetPercent(Num1 As Long, Num2 As Long) As Integer
  //    GetPercent = 100 \ (Num2 / Num1)
  //End Function
  function UnSpace( var exp : widestring ) : widestring;
  function HexDec( var h : widestring ) : longint;

  procedure SetWindowPos( hWnd : longint; hWndInsertAfter : longint; X : longint; Y : longint; cx : longint; cy : longint; wFlags : longint ); stdcall; external 'user32';
  function GetPixel( hDC : longint; X : longint; Y : longint ) : longint; stdcall; external 'gdi32';
  function SetWindowRgn( hWnd : longint; hRgn : longint; bRedraw : wordbool ) : longint; stdcall; external 'user32';
  function CreateRectRgn( X1 : longint; Y1 : longint; X2 : longint; Y2 : longint ) : longint; stdcall; external 'gdi32';
  function CombineRgn( hDestRgn : longint; hSrcRgn1 : longint; hSrcRgn2 : longint; nCombineMode : longint ) : longint; stdcall; external 'gdi32'; // A sample by Yaniv Drukman: www.dr-vb.co.il
  function SendMessage( hWnd : longint; wMsg : longint; wParam : longint; var lParam ) : longint; stdcall; external 'user32' name 'SendMessageA';
  function ReleaseCapture : longint; stdcall; external 'user32';
  function DeleteObject( hObject : longint ) : longint; stdcall; external 'gdi32';
  function SetTimer( hWnd : longint; nIDEvent : longint; uElapse : longint; lpTimerFunc : longint ) : longint; stdcall; external 'user32';
  function KillTimer( hWnd : longint; nIDEvent : longint ) : longint; stdcall; external 'user32';
  function OffsetRgn( hRgn : longint; X : longint; Y : longint ) : longint; stdcall; external 'gdi32';
  function CreateEllipticRgn( X1 : longint; Y1 : longint; X2 : longint; Y2 : longint ) : longint; stdcall; external 'gdi32';
  function CreateRoundRectRgn( X1 : longint; Y1 : longint; X2 : longint; Y2 : longint; X3 : longint; Y3 : longint ) : longint; stdcall; external 'gdi32';
  function waveOutSetVolume( wDeviceID : smallint; dwVolume : longint ) : smallint; stdcall; external 'Winmm';
  function waveOutGetVolume( wDeviceID : smallint; var dwVolume : longint ) : smallint; stdcall; external 'Winmm';
  function midiOutSetVolume( mDeviceID : smallint; dmVolume : longint ) : smallint; stdcall; external 'Winmm';
  function midiOutGetVolume( mDeviceID : smallint; var dmVolume : longint ) : smallint; stdcall; external 'Winmm';

implementation

  procedure SetVol( var Volume : smallint; var Midi : boolean );
    var
      //v = 15
      X : longint; 
    begin
      if ( Volume > 50 )
        then
          begin
            if ( Volume = 100 )
              then
                begin
                  if Midi
                    then
                      begin
                        midiOutSetVolume( 0, $FFFFFFFF );
                      end
                    else
                      begin
                        waveOutSetVolume( 0, $FFFFFFFF );
                      end;
                end
              else
                begin
                  X := -( ( 32767 / 50 ) * ( 100 - Volume ) );
                  if Midi
                    then
                      begin
                        midiOutSetVolume( 0, X + ( X * 65536 ) );
                      end
                    else
                      begin
                        waveOutSetVolume( 0, X + ( X * 65536 ) );
                      end;
                end;
          end
        else
          begin
            X := Floor( ( 32767 / 50 ) * Volume );
            if Midi
              then
                begin
                  midiOutSetVolume( 0, X + ( X * 65536 ) );
                end
              else
                begin
                  waveOutSetVolume( 0, X + ( X * 65536 ) );
                end;
          end;
    end;

  function GetVol( var Midi : boolean ) : smallint;
    var
      v : longint; 
      X : longint; 
      xh : widestring; 
    begin
      if Midi
        then
          begin
            midiOutGetVolume( 0, X );
          end
        else
          begin
            waveOutGetVolume( 0, X );
          end;
      xh := HexDec( RightStr(Hex( X ), 4) ); //, 16, 10) ') ', 16, 10))
      v := Round( Val( xh ) / 655.36 );
      result := v;
    end;

  function MakeRegion( var picSkin : TPaintBox ) : longint;
    var
      X : longint; 
      Y : longint; 
      StartLineX : longint; 
      FullRegion : longint; 
      LineRegion : longint; 
      TransparentColor : longint; 
      InFirstRegion : boolean; 
      InLine : boolean; 
      hDC : longint; 
      PicWidth : longint; 
      PicHeight : longint; 
    begin
      hDC := picSkin.Canvas.Handle;
      PicWidth := picSkin.ScaleWidth;
      PicHeight := picSkin.ScaleHeight;
      InFirstRegion := true;
      InLine := false;
      X := ( Y = StartLineX = 0 );
      //        
      //     ,  
      //       
      //         
      TransparentColor := GetPixel( hDC, 0, 0 );
      for Y := 0 to PicHeight - 1 do
        begin
          for X := 0 to PicWidth - 1 do
            begin
              if ( GetPixel( hDC, X, Y ) = TransparentColor ) or ( X = PicWidth )
                then
                  begin
                    //     
                    if InLine
                      then
                        begin
                          InLine := false;
                          LineRegion := CreateRectRgn( StartLineX, Y, X, Y + 1 );
                          if InFirstRegion
                            then
                              begin
                                FullRegion := LineRegion;
                                InFirstRegion := false;
                              end
                            else
                              begin
                                CombineRgn( FullRegion, FullRegion, LineRegion, 2 ); // A sample by Yaniv Drukman: www.dr-vb.co.il
                                //     
                                DeleteObject( LineRegion );
                              end;
                        end;
                  end
                else
                  begin
                    //    
                    if not InLine
                      then
                        begin
                          InLine := true;
                          StartLineX := X;
                        end;
                  end;
            end;
        end;
      result := FullRegion;
    end;

  function Percent( var Val : longint; var Percnt : smallint ) : longint;
    begin
      result := Val * ( Percnt / 100 );
    end;

  function UnSpace( var exp : widestring ) : widestring;
    var
      i : smallint; 
    begin
      for i := 1 to length( exp ) do
        begin
          if ( LeftStr(RightStr(exp, i), 1) <> Chr( 32 ) )
            then
              begin
                if ( LeftStr(RightStr(exp, i), 1) <> Chr( 0 ) )
                  then
                    begin
                      break;
                    end;
              end;
        end;
      result := LeftStr(exp, length( exp ) - ( i - 1 ));
    end;

  function HexDec( var h : widestring ) : longint;
    var
      i : smallint; 
      cnt : longint; 
    begin
      h := LowerCase(h);
      for i := 1 to length( h ) do
        begin
          tmp{DECLARE} := Copy(h, i, 1);
          if ( tmp = '1' )
            then
              begin
                cnt := cnt + Power( 1 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '2' )
            then
              begin
                cnt := cnt + Power( 2 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '3' )
            then
              begin
                cnt := cnt + Power( 3 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '4' )
            then
              begin
                cnt := cnt + Power( 4 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '5' )
            then
              begin
                cnt := cnt + Power( 5 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '6' )
            then
              begin
                cnt := cnt + Power( 6 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '7' )
            then
              begin
                cnt := cnt + Power( 7 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '8' )
            then
              begin
                cnt := cnt + Power( 8 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = '9' )
            then
              begin
                cnt := cnt + Power( 9 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'a' )
            then
              begin
                cnt := cnt + Power( 10 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'b' )
            then
              begin
                cnt := cnt + Power( 11 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'c' )
            then
              begin
                cnt := cnt + Power( 12 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'd' )
            then
              begin
                cnt := cnt + Power( 13 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'e' )
            then
              begin
                cnt := cnt + Power( 14 * 16, ( length( h ) - i ) );
              end
            else
          if ( tmp = 'f' )
            then
              begin
                cnt := cnt + Power( 15 * 16, ( length( h ) - i ) );
              end;
          //If Mid(h, i, 1) = "1" Then cnt = cnt + 1 * 16 ^ (Len(h) - i - 0))
          //If Mid(h, i, 1) = "2" Then cnt = cnt + 2 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "3" Then cnt = cnt + 3 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "4" Then cnt = cnt + 4 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "5" Then cnt = cnt + 5 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "6" Then cnt = cnt + 6 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "7" Then cnt = cnt + 7 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "8" Then cnt = cnt + 8 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "9" Then cnt = cnt + 9 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "a" Then cnt = cnt + 10 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "b" Then cnt = cnt + 11 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "c" Then cnt = cnt + 12 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "d" Then cnt = cnt + 13 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "e" Then cnt = cnt + 14 * 16 ^ (Len(h) - (i - 0))
          //If Mid(h, i, 1) = "f" Then cnt = cnt + 15 * 16 ^ (Len(h) - (i - 0))
        end;
      result := cnt;
    end;

end.
