unit OpenDialog;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  function OpenDlg( var hWnd : longint; var Filter : widestring{ = ''}; var Title : widestring{ = 'Select file'}; var InitialDir : widestring{ = ''}; var MultiSelect : boolean{ = false} ) : olevariant;

implementation

  const
    OFN_HIDEREADONLY : longint = $00000004; 
    OFN_EXPLORER : longint = $00080000; 
    OFN_ALLOWMULTISELECT : longint = $00000200; 

  type
    OPENFILENAME = 
      packed record
        lStructSize : longint; 
        hwndOwner : longint; 
        hInstance : longint; 
        lpstrFilter : widestring; 
        lpstrCustomFilter : widestring; 
        nMaxCustFilter : longint; 
        nFilterIndex : longint; 
        lpstrFile : widestring; 
        nMaxFile : longint; 
        lpstrFileTitle : widestring; 
        nMaxFileTitle : longint; 
        lpstrInitialDir : widestring; 
        lpstrTitle : widestring; 
        flags : longint; 
        nFileOffset : smallint; 
        nFileExtension : smallint; 
        lpstrDefExt : widestring; 
        lCustData : longint; 
        lpfnHook : longint; 
        lpTemplateName : widestring; 
      end;

  function GetOpenFileName( var pOpenfilename : OPENFILENAME ) : longint; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';

  function OpenDlg( var hWnd : longint; var Filter : widestring; var Title : widestring; var InitialDir : widestring; var MultiSelect : boolean ) : olevariant;
    const
      {$WRITEABLECONST ON}
      InDir : widestring = '';
      {$WRITEABLECONST OFF}
    var
      OFName : OPENFILENAME; 
    begin
      while ( PosEx('|', Filter, 1) > 0 ) do
        begin
          //Replace all '|' chars in the filter with spaces
          Filter := StuffString( Filter, PosEx('|', Filter, 1), length( Chr( 0 ) ), Chr( 0 ) );
        end;
      if ( InDir = '' )
        then
          begin
            InDir := App.Path;
          end;
      //load the last directory path if is it missing
      if ( InitialDir = '' )
        then
          begin
            InitialDir := InDir;
          end;
      OFName.lStructSize := sizeof( OFName );
      //Set the parent window
      OFName.hwndOwner := hWnd;
      //Set the application's instance
      OFName.hInstance := App.hInstance;
      //Select a filter
      OFName.lpstrFilter := Filter;
      //create a buffer for the file
      OFName.lpstrFile := StringOfChar(#32, 10000);
      //set the maximum length of a returned file
      OFName.nMaxFile := 10001;
      //Create a buffer for the file title
      OFName.lpstrFileTitle := StringOfChar(#32, 10000);
      //Set the maximum length of a returned file title
      OFName.nMaxFileTitle := 10001;
      //Set the initial directory
      OFName.lpstrInitialDir := InitialDir;
      //Set the title
      OFName.lpstrTitle := Title; //"Open File - KPD-Team 1998"
      //Hide the readonly check box
      OFName.flags := OFN_HIDEREADONLY;
      if MultiSelect
        then
          begin
            //Allow multi file selection
            OFName.flags := OFName.flags or OFN_EXPLORER or OFN_ALLOWMULTISELECT;
          end;
      //Show the open dialog
      if ( GetOpenFileName( OFName ) = 1 )
        then
          begin
            result := Trim( OFName.lpstrFile );
            //Save the file path
            InDir := LeftStr(OFName.lpstrFile, length( Trim( OFName.lpstrFile ) ) - length( Trim( OFName.lpstrFileTitle ) )) + '\';
          end
        else
          begin
            result := '?';
          end;
    end;

end.
