Attribute VB_Name = "mWndProcex"
Option Explicit
'
' Copyright  1997-2000 Brad Martinez, http://www.mvps.org
'
' Code was written in and formatted for 8pt MS San Serif

Private Const WM_DESTROY = &H2
Public Const WM_SETREDRAW = &HB
Private Const WM_STYLECHANGING = &H7C

Private Type STYLESTRUCT
  styleOld  As Long
  styleNew  As Long
End Type

Public g_fEatStyleChanging As Boolean

Private Const LVS_NOLABELWRAP = &H80

'Private Const LVN_FIRST = -100&   ' (0U-100U)
'Private Const LVN_GETDISPINFOA = (LVN_FIRST - 50)
'
'Private Const WM_USER = &H400
'Private Const OCM__BASE = (WM_USER + &H1C00)
'Private Const WM_NOTIFY = &H4E
'Private Const OCM_NOTIFY = (OCM__BASE + WM_NOTIFY)   ' (OCM__BASE + &H4E)

'' The NMHDR structure contains information about a notification message. The pointer
'' to this structure is specified as the lParam member of the WM_NOTIFY message.
'Private Type NMHDR
'  hwndFrom As Long   ' Window handle of control sending message
'  idFrom As Long        ' Identifier of control sending message
'  code  As Long          ' Specifies the notification code
'End Type

' =====================================================================

' Allocated string pointer filled with OLDWNDPROC string and used with all
' CallWindowProc(GetProp(hwnd, m_lpszOldWndProc), ...) calls.
Private m_lpszOldWndProc As Long
Private m_lpszObjPtr As Long

Private m_nSubclasses  As Long

Private Const OLDWNDPROC = "OldWndProc"
Private Const OBJECTPTR = "ObjectPtr"

Private Const LMEM_FIXED = &H0
Private Const LMEM_ZEROINIT = &H40
Private Const LPTR = (LMEM_FIXED Or LMEM_ZEROINIT)
Private Declare Function LocalAlloc Lib "kernel32" (ByVal uFlags As Long, ByVal uBytes As Long) As Long
Private Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function lstrcpyA Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long

Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As Any) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As Any, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As Any) As Long

Public Enum GWL_nIndex
  GWL_WNDPROC = (-4)
'  GWL_HWNDPARENT = (-8)
  GWL_ID = (-12)
  GWL_STYLE = (-16)
  GWL_EXSTYLE = (-20)
'  GWL_USERDATA = (-21)
End Enum

Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As GWL_nIndex) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As GWL_nIndex, ByVal dwNewLong As Long) As Long

Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


Public Function SubClass(hwnd As Long, _
                                         lpfnNew As Long, _
                                         Optional objNotify As Object = Nothing) As Boolean
  Dim lpfnOld As Long
  Dim fSuccess As Boolean
  On Error GoTo Out
  
  If GetProp(hwnd, OLDWNDPROC) Then
    SubClass = True
    Exit Function
  End If
  
  If lpfnOld Then
    fSuccess = SetProp(hwnd, OLDWNDPROC, lpfnOld)
    If (objNotify Is Nothing) = False Then
      fSuccess = fSuccess And SetProp(hwnd, OBJECTPTR, ObjPtr(objNotify))
    End If
  End If
  
Out:
  If fSuccess Then
    ' allocate m_lpszOldWndProc and m_lpszObjPtr if first subclass
    m_nSubclasses = m_nSubclasses + 1
    If (m_nSubclasses = 1) Then
      m_lpszOldWndProc = LocalAlloc(LPTR, Len(OLDWNDPROC))
      If m_lpszOldWndProc Then
        Call lstrcpyA(ByVal m_lpszOldWndProc, ByVal OLDWNDPROC)
      End If
      m_lpszObjPtr = LocalAlloc(LPTR, Len(OBJECTPTR))
      If m_lpszObjPtr Then
        Call lstrcpyA(ByVal m_lpszObjPtr, ByVal OBJECTPTR)
      End If
    End If
    SubClass = True
  
  Else
    If lpfnOld Then Call SetWindowLong(hwnd, GWL_WNDPROC, lpfnOld)
    MsgBox "Error subclassing window &H" & Hex(hwnd) & vbCrLf & vbCrLf & _
                  "Err# " & Err.Number & ": " & Err.Description, vbExclamation
  End If
  
End Function

Public Function UnSubClass(hwnd As Long) As Boolean
  Dim lpfnOld As Long
  
  lpfnOld = GetProp(hwnd, OLDWNDPROC)
  If lpfnOld Then
    
    If SetWindowLong(hwnd, GWL_WNDPROC, lpfnOld) Then
      Call RemoveProp(hwnd, OLDWNDPROC)
      Call RemoveProp(hwnd, OBJECTPTR)
      
      ' deallocate and zero m_lpszOldWndProc and m_lpszObjPtr if last unsubclass
      m_nSubclasses = m_nSubclasses - 1
      If (m_nSubclasses = 0) Then
        If m_lpszOldWndProc Then
          If LocalFree(m_lpszOldWndProc) Then m_lpszOldWndProc = 0
        End If
        If m_lpszObjPtr Then
          If LocalFree(m_lpszObjPtr) Then m_lpszObjPtr = 0
        End If
      End If
      
      UnSubClass = True
    
    End If   ' SetWindowLong
  End If   ' lpfnOld

End Function

Public Static Function LVWndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  Select Case uMsg
      
    ' ============================================================
    ' If the flag is set and the ListView's LVS_NOLABELWRAP stye bit is changing
    ' (the ListView's LabelWrap property), prevent the style change and the resultant
    ' unnecessary redrawing, flickering, and a serious degradation in loading speed.
    
    Case WM_STYLECHANGING
      Dim ss As STYLESTRUCT
      
      If g_fEatStyleChanging Then
        MoveMemory ss, ByVal lParam, Len(ss)
        If ((ss.styleOld Xor ss.styleNew) And LVS_NOLABELWRAP) Then
          ss.styleNew = ss.styleOld
          MoveMemory ByVal lParam, ss, Len(ss)
        End If
      End If
            
'    ' ============================================================
'    Case OCM_NOTIFY
'      Dim nmh As NMHDR
'
'      If g_fEatStyleChanging Then  ' Exit Function
'        MoveMemory nmh, ByVal lParam, Len(nmh)
'        If (nmh.code = LVN_GETDISPINFOA) Then Exit Function
'      End If
    
    ' ============================================================
    ' Unsubclass the window.
    
    Case WM_DESTROY
      ' m_lpszOldWndProc will be gone after UnSubClass is called!
      Call CallWindowProc(GetProp(hwnd, m_lpszOldWndProc), hwnd, uMsg, wParam, lParam)
      Call UnSubClass(hwnd)
      Exit Function
      
  End Select   ' uMsg
  
  LVWndProc = CallWindowProc(GetProp(hwnd, m_lpszOldWndProc), hwnd, uMsg, wParam, lParam)
  
End Function