unit mMenuDefs;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  const
    // Brought to you by Brad Martinez
    //   http://members.aol.com/btmtz/vb
    //   http://www.mvps.org/ccrp
    //
    // Code was written in and formatted for 8pt MS San Serif
    //
    // Note that "IShellFolder Extended Type Library v1.2" (ISHF_Ex.tlb)
    // included with this project, must be present and correctly registered
    // on your system, and referenced by this project, to allow use of the
    // IShellFolder, IContextMenu and IMalloc interfaces.
    // ====================================================
    // C language BOOLEAN constants
    CFalse : boolean = false; 
    CTrue : smallint = 1; 
    LB_ERR : smallint = -1; 
    LB_SETSEL : smallint = $00000185;  // multi-selection lbs only
    LB_SETCURSEL : smallint = $00000186;  // single selection lbs only
    LB_GETCOUNT : smallint = $0000018B; 
    LB_SETCARETINDEX : smallint = $0000019E;  // multi-selection lbs only

  type
    // ShowWindow commands
    SW_cmds = (
      SW_HIDE = 0, 
      SW_NORMAL = 1, 
      SW_SHOWNORMAL = 1, 
      SW_SHOWMINIMIZED = 2, 
      SW_MAXIMIZE = 3, 
      SW_SHOWMAXIMIZED = 3, 
      SW_SHOWNOACTIVATE = 4, 
      SW_SHOW = 5, 
      SW_MINIMIZE = 6, 
      SW_SHOWMINNOACTIVE = 7, 
      SW_SHOWNA = 8, 
      SW_RESTORE = 9, 
      SW_MAX = 10, 
      SW_SHOWDEFAULT = 10
      );
    TPM_wFlags = (
      TPM_LEFTBUTTON = $00000000, 
      TPM_RIGHTBUTTON = $00000002, 
      TPM_LEFTALIGN = $00000000, 
      TPM_CENTERALIGN = $00000004, 
      TPM_RIGHTALIGN = $00000008, 
      TPM_TOPALIGN = $00000000, 
      TPM_VCENTERALIGN = $00000010, 
      TPM_BOTTOMALIGN = $00000020, 
      TPM_HORIZONTAL = $00000000,  // Horz alignment matters more
      TPM_VERTICAL = $00000040,  // Vert alignment matters more
      TPM_NONOTIFY = $00000080,  // Don't send any notification msgs
      TPM_RETURNCMD = $00000100
      );
    MII_Mask = (
      MIIM_STATE = $00000001, 
      MIIM_ID = $00000002, 
      MIIM_SUBMENU = $00000004, 
      MIIM_CHECKMARKS = $00000008, 
      MIIM_TYPE = $00000010, 
      MIIM_DATA = $00000020
      );
    // win40  -- A lot of MF_* flags have been renamed as MFT_* and MFS_* flags
    MenuFlags = (
      MF_INSERT = $00000000, 
      MF_ENABLED = $00000000, 
      MF_UNCHECKED = $00000000, 
      MF_BYCOMMAND = $00000000, 
      MF_STRING = $00000000, 
      MF_UNHILITE = $00000000, 
      MF_GRAYED = $00000001, 
      MF_DISABLED = $00000002, 
      MF_BITMAP = $00000004, 
      MF_CHECKED = $00000008, 
      MF_POPUP = $00000010, 
      MF_MENUBARBREAK = $00000020, 
      MF_MENUBREAK = $00000040, 
      MF_HILITE = $00000080, 
      MF_CHANGE = $00000080, 
      MF_END = $00000080,  // Obsolete -- only used by old RES files
      MF_APPEND = $00000100, 
      MF_OWNERDRAW = $00000100, 
      MF_DELETE = $00000200, 
      MF_USECHECKBITMAPS = $00000200, 
      MF_BYPOSITION = $00000400, 
      MF_SEPARATOR = $00000800, 
      MF_REMOVE = $00001000, 
      MF_DEFAULT = $00001000, 
      MF_SYSMENU = $00002000, 
      MF_HELP = $00004000, 
      MF_RIGHTJUSTIFY = $00004000, 
      MF_MOUSESELECT = $00008000
      );
    MF_Type = (
      MFT_STRING = MF_STRING, 
      MFT_BITMAP = MF_BITMAP, 
      MFT_MENUBARBREAK = MF_MENUBARBREAK, 
      MFT_MENUBREAK = MF_MENUBREAK, 
      MFT_OWNERDRAW = MF_OWNERDRAW, 
      MFT_RADIOCHECK = $00000200, 
      MFT_SEPARATOR = MF_SEPARATOR, 
      MFT_RIGHTORDER = $00002000, 
      MFT_RIGHTJUSTIFY = MF_RIGHTJUSTIFY
      );
    MF_State = (
      MFS_GRAYED = $00000003, 
      MFS_DISABLED = MFS_GRAYED, 
      MFS_CHECKED = MF_CHECKED, 
      MFS_HILITE = MF_HILITE, 
      MFS_ENABLED = MF_ENABLED, 
      MFS_UNCHECKED = MF_UNCHECKED, 
      MFS_UNHILITE = MF_UNHILITE, 
      MFS_DEFAULT = MF_DEFAULT
      );

    POINTAPI =  // pt
      packed record
        x : longint; 
        y : longint; 
      end;

    MENUITEMINFO = 
      packed record
        cbSize : longint; 
        fMask : MII_Mask; 
        fType : MF_Type;  // MIIM_TYPE
        fState : MF_State;  // MIIM_STATE
        wID : longint;  // MIIM_ID
        hSubMenu : longint;  // MIIM_SUBMENU
        hbmpChecked : longint;  // MIIM_CHECKMARKS
        hbmpUnchecked : longint;  // MIIM_CHECKMARKS
        dwItemData : longint;  // MIIM_DATA
        dwTypeData : widestring;  // MIIM_TYPE
        cch : longint;  // MIIM_TYPE
      end;

  //
  // Displays the specified items' shell context menu.
  //
  //    hwndOwner  - window handle that owns context menu and any err msgboxes
  //    isfParent       - pointer to the items' parent shell folder
  //    cPidls            - count of pidls at, and after, pidlRel
  //    pidlRel          - the first item's pidl, relative to isfParent
  //    pt                  - location of the context menu, in screen coords
  //    fPrompt         - flag specifying whether to prompt before executing any selected
  //                           context menu command
  //
  // Returns True if a context menu command was selected, False otherwise.
  function ShowShellContextMenu( var hwndOwner : longint; var isfParent : IShellFolder; var cPidls : smallint; var pidlRel : longint; var pt : POINTAPI; var fPrompt : boolean ) : boolean;
  // Returns the string of the specified menu command ID in the specified menu.
  function GetMenuCmdStr( var hMenu : longint; var idCmd : smallint ) : widestring;

  procedure MoveMemory( var pDest; var pSource; dwLength : longint ); stdcall; external 'kernel32' name 'RtlMoveMemory';
  function SendMessage( hWnd : longint; wMsg : longint; wParam : longint; var lParam ) : longint; stdcall; external 'user32' name 'SendMessageA';
  // Returns the listbox index if the specified point is over a list item,
  // or - 1 otherwise. The ptX & ptY params want to be screen coords.
  // Requires a tad more coding to make bAutoScroll functional but
  // works nicely when dragging...
  function LBItemFromPt( hLB : longint; ptX : longint; ptY : longint; bAutoScroll : longint ) : longint; stdcall; external 'comctl32.dll';
  // Converts the specified window's client coordinates to screen coordinates
  function ClientToScreen( hWnd : longint; var lpPoint : POINTAPI ) : longint; stdcall; external 'user32';
  // ====================================================
  // menu defs
  function CreatePopupMenu : longint; stdcall; external 'user32';
  function DestroyMenu( hMenu : longint ) : longint; stdcall; external 'user32';
  function TrackPopupMenu( hMenu : longint; wFlags : TPM_wFlags; x : longint; y : longint; nReserved : longint; hWnd : longint; var lprc ) : longint; stdcall; external 'user32'; // lprc As RECT
  function GetMenuItemInfo( hMenu : longint; uItem : longint; fByPosition : wordbool; var lpmii : MENUITEMINFO ) : boolean; stdcall; external 'user32' name 'GetMenuItemInfoA';
  function InsertMenuItem( hMenu : longint; uItem : longint; fByPosition : wordbool; var lpmii : MENUITEMINFO ) : boolean; stdcall; external 'user32' name 'InsertMenuItemA';

implementation

  function ShowShellContextMenu( var hwndOwner : longint; var isfParent : IShellFolder; var cPidls : smallint; var pidlRel : longint; var pt : POINTAPI; var fPrompt : boolean ) : boolean;
    const
      idOurCmd : smallint = 100; 
      sOurCmd : widestring = '&Our menu command :-)'; 
    var
      IID_IContextMenu : GUID; 
      IID_IContextMenu2 : GUID; 
      icm : IContextMenu; 
      hr : longint;  // HRESULT
      hMenu : longint; 
      idCmd : longint; 
      cmi : CMINVOKECOMMANDINFO; 
      // <optional>
      mii : MENUITEMINFO; 
    begin
      // </optional>
      // Fill the IContextMenu interface ID, {000214E4-000-000-C000-000000046}
      with IID_IContextMenu do
        begin
          Data1 := $000214E4;
          Data4[0] := $000000C0;
          Data4[7] := $00000046;
        end;
      // Get a refernce to the item's IContextMenu interface.
      hr := isfParent.GetUIObjectOf( hwndOwner, cPidls, pidlRel, IID_IContextMenu, 0, icm );
      if ( hr >= NOERROR )
        then
          begin
            // Fill the IContextMenu2 interface ID, {000214F4-000-000-C000-000000046}
            // and get the folder's IContextMenu2. Is needed so the "Send To" and "Open
            // With" submenus get filled from the HandleMenuMsg call in WndProc.
            with IID_IContextMenu2 do
              begin
                Data1 := $000214F4;
                Data4[0] := $000000C0;
                Data4[7] := $00000046;
              end;
            icm.QueryInterface( IID_IContextMenu2, ICtxMenu2 );
            // Create a new popup menu...
            hMenu := CreatePopupMenu;
            if hMenu
              then
                begin
                  // Add the item's shell commands to the popup menu.
                  if ( ( ICtxMenu2 = nil ) = false )
                    then
                      begin
                        hr := ICtxMenu2.QueryContextMenu( hMenu, 0, 1, $00007FFF, CMF_EXPLORE );
                      end
                    else
                      begin
                        hr := icm.QueryContextMenu( hMenu, 0, 1, $00007FFF, CMF_EXPLORE );
                      end;
                  if ( hr >= NOERROR )
                    then
                      begin
                        // ===================================================
                        // <optional>
                        // Now for fun, we'll add a menu item to the top of the context menu
                        mii.cbSize := sizeof( mii );
                        mii.fMask := MIIM_ID or MIIM_TYPE;
                        mii.wID := idOurCmd;
                        mii.fType := MFT_STRING;
                        mii.dwTypeData := sOurCmd;
                        mii.cch := length( sOurCmd );
                        InsertMenuItem( hMenu, 0, true, mii );
                        // </optional>
                        // ===================================================
                        // Show the item's context menu
                        idCmd := TrackPopupMenu( hMenu, TPM_LEFTALIGN or TPM_RETURNCMD or TPM_RIGHTBUTTON, pt.x, pt.y, 0, hwndOwner, 0 );
                        // If a menu command is selected...
                        if idCmd
                          then
                            begin
                              // ===================================================
                              // <optional>
                              // If prompting before executing the command...
                              if fPrompt
                                then
                                  begin
                                    if ( Application.MessageBox( pchar('The "' + GetMenuCmdStr( hMenu, ( idCmd ) ) + '" context menu command was chosen.' + vbCrLf + 'Execute the command?'), pchar(''), vbQuestion or vbYesNo ) {HelpFile:None, Context:None} = vbNo )
                                      then
                                        begin
                                          idCmd := 0;
                                        end;
                                  end; // fPrompt
                              // If the selected menu command is our command, we're responsible
                              // for excuting it. The InvokeCommand below, which will also attempt
                              // to execute it if selected, will fail since there is no corresponding verb
                              // for our command in any registered file type (i.e."Open", etc.).
                              if ( idCmd = idOurCmd )
                                then
                                  begin
                                    Application.MessageBox( pchar('We just executed ' + sOurCmd), pchar(''), MB_OK ) {HelpFile:None, Context:None};
                                  end;
                              // </optional>
                              // ===================================================
                              // If still executing the command...
                              if idCmd
                                then
                                  begin
                                    // Fill the struct with the selected command's information.
                                    with cmi do
                                      begin
                                        cbSize := sizeof( cmi );
                                        hWnd := hwndOwner;
                                        lpVerb := idCmd - 1; // MAKEINTRESOURCE(idCmd-1);
                                        nShow := SW_SHOWNORMAL;
                                      end;
                                    // Invoke the shell's context menu command. The call itself does
                                    // not err if the pidlRel item is invalid, but depending on the selected
                                    // command, Explorer *may* raise an err. We don't need the return
                                    // val, which should always be NOERROR anyway...
                                    if ( ( ICtxMenu2 = nil ) = false )
                                      then
                                        begin
                                          ICtxMenu2.InvokeCommand( cmi );
                                        end
                                      else
                                        begin
                                          icm.InvokeCommand( cmi );
                                        end;
                                  end; // idCmd
                            end; // idCmd
                      end; // hr >= NOERROR (QueryContextMenu)
                  DestroyMenu( hMenu );
                end; // hMenu
          end; // hr >= NOERROR (GetUIObjectOf)
      // Release the folder's IContextMenu2 from the global variable.
      ICtxMenu2 := nil;
      // Return True if a menu command was selected
      // (letting us know to react accordingly...)
      result := boolean( idCmd );
    end;

  function GetMenuCmdStr( var hMenu : longint; var idCmd : smallint ) : widestring;
    var
      mii : MENUITEMINFO; 
    begin
      // Initialize the struct..
      with mii do
        begin
          cbSize := sizeof( mii );
          fMask := MIIM_TYPE;
          fType := MFT_STRING;
          dwTypeData := StringOfChar( 0, 256 );
          cch := 256;
        end;
      // Returns TRUE on success
      if GetMenuItemInfo( hMenu, idCmd, false, mii )
        then
          begin
            result := LeftStr(mii.dwTypeData, mii.cch);
          end;
    end;

end.
